/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package views;

import javax.swing.JOptionPane;
import controllers.EstadoController;
/**
 *
 * @author jaimearroyo
 */
public class EstadoEditNew extends javax.swing.JFrame {
    EstadoController estado = new EstadoController();
    /**
     * Creates new form CategoryNewEdit
     */
    public EstadoEditNew() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        header_category = new javax.swing.JLabel();
        label_name_cat = new javax.swing.JLabel();
        txt_name_cat = new javax.swing.JTextField();
        boton_guardar = new javax.swing.JButton();
        boton_listado = new javax.swing.JButton();
        label_accion = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        header_category.setFont(new java.awt.Font("Lucida Grande", 0, 18)); // NOI18N
        header_category.setText("Estados");

        label_name_cat.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat.setText("Estado:");

        txt_name_cat.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txt_name_catActionPerformed(evt);
            }
        });

        boton_guardar.setText("Guardar");
        boton_guardar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boton_guardarActionPerformed(evt);
            }
        });

        boton_listado.setText("Listado de estados");
        boton_listado.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boton_listadoActionPerformed(evt);
            }
        });

        label_accion.setText("Ingresar nuevo estado");
        label_accion.setToolTipText("");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(152, 152, 152)
                        .addComponent(header_category))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(34, 34, 34)
                        .addComponent(label_name_cat)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txt_name_cat, javax.swing.GroupLayout.PREFERRED_SIZE, 266, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(layout.createSequentialGroup()
                            .addContainerGap()
                            .addComponent(boton_listado, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addGap(106, 106, 106)
                            .addComponent(boton_guardar, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(44, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addComponent(label_accion)
                .addGap(115, 115, 115))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(header_category)
                .addGap(17, 17, 17)
                .addComponent(label_accion, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_name_cat)
                    .addComponent(txt_name_cat, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(43, 43, 43)
                .addComponent(boton_guardar, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(boton_listado, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(34, Short.MAX_VALUE))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void txt_name_catActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txt_name_catActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txt_name_catActionPerformed
/**
 * Captura acción click del boton guardar, toma los valores de los campos se los pasa al controlador
 * @param evt evento click en el botón
 */
    private void boton_guardarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boton_guardarActionPerformed

            if(!txt_name_cat.getText().equals("")){

                    estado.newone(txt_name_cat.getText());

                    if(estado.save() != -1){
                        JOptionPane.showMessageDialog(null, "Registro guardado/actualziado correctamente");
                        this.ir_a_listado();
                    }else{
                        JOptionPane.showMessageDialog(null, "Error al insertar/actualizar, vuelva a intentar");
                    }

            }else{
                JOptionPane.showMessageDialog(null, "Debes llenar todos los campos");
            }

    }//GEN-LAST:event_boton_guardarActionPerformed
    /**
     * Evento click en el boton volver al listado, ejecuta el metodo ir_a_listado de la clase
     * @param evt evento click del boton
     */
    private void boton_listadoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boton_listadoActionPerformed
        this.ir_a_listado();
    }//GEN-LAST:event_boton_listadoActionPerformed

    /**
     * Genera una vista de listado, oculta la actual y muesta la vista del listado generada
     */
    public void ir_a_listado(){
        EstadoIndex index_estado =new EstadoIndex();
        this.setVisible(false);
        index_estado.setVisible(true);
    }
    
    /**
     * Tiene como parametro una instancia de EstadoController con lo que a la vista actual se le 
     * setean los valores del formulario y se modifican unas etiquetas, esto
     * se ejecuta solo cuando se esta editando
     * @param estado_controller instancia de EstadoController 
     */
    public void set_estado_controller(EstadoController estado_controller){
        this.estado = estado_controller;
        Object[] categoria_obj = estado_controller.get_fields();
        txt_name_cat.setText(categoria_obj[1].toString());
        boton_guardar.setText("Actualizar");
        label_accion.setText("Editando estado id: "+categoria_obj[0].toString());
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(EstadoEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(EstadoEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(EstadoEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(EstadoEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new EstadoEditNew().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton boton_guardar;
    private javax.swing.JButton boton_listado;
    private javax.swing.JLabel header_category;
    private javax.swing.JLabel label_accion;
    private javax.swing.JLabel label_name_cat;
    private javax.swing.JTextField txt_name_cat;
    // End of variables declaration//GEN-END:variables
}
